﻿
using C1.Win.FlexReport;
using Microsoft.AspNetCore.Mvc;
using System;
using System.IO;
using System.Collections.Generic;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace C1WebApi_Report.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class ReportController : ControllerBase
    {
        // GET: api/<Report>
        private string _reportpath = Path.Combine(Directory.GetCurrentDirectory(), @"wwwroot/Reports");
        private string _pdfPath = Path.Combine(Directory.GetCurrentDirectory(), @"wwwroot/Output");
        [HttpGet]
        public IEnumerable<string> Get()
        {

            var files = Directory.GetFiles(_reportpath);
            int count = files.Length;
            string[] fileNames = new string[count] ;
            for (int i = 0; i < files.Length; i++)
            {
                fileNames.SetValue(Path.GetFileNameWithoutExtension(files[i]), i);
            }
            return fileNames;//new string[] { "value1", "value2" };
        }

        // GET api/<Report>/5
        [HttpGet("{reportName}")]
        public string Get(string id ="Test")
        {
            System.Data.DataTable dt = new System.Data.DataTable();
            dt.Columns.Add("Test");
            dt.Columns.Add("Test2");

            dt.Rows.Add(dt.NewRow());
            dt.Rows.Add(dt.NewRow());

            string nameReport = "Test";
            string fileReport = Path.Combine(_reportpath, id + ".flxr");
            string fileToSave = Path.Combine(_pdfPath, id + ".pdf"); ;
            C1FlexReport rpt = new C1FlexReport();
            rpt.Load(fileReport, nameReport);
            rpt.DataSource.Recordset = dt;

            C1.Win.Document.Export.PdfFilter exp = new C1.Win.Document.Export.PdfFilter();
            exp.FileName = fileToSave;
            exp.PdfACompatible = true;
            exp.EmbedFonts = true;
            rpt.Export(exp);

            return "File in "+fileToSave;
            
        }

        
    }
}
